default:
  image: '$ID_IMAGE'
  before_script:
    - pnpm install --frozen-lockfile
  timeout: 1m

.rules_unscheduled:
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
      when: never
    - when: always

.rules_scheduled:
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
      when: always
    - when: never

build:
  artifacts:
    paths:
      - build/
  image: '$ID_IMAGE'
  needs: ['build container image', 'lint', 'webhint']
  rules:
    - !reference [.rules_unscheduled, rules]
  script:
    - pnpm build --optimize
  timeout: 5m

build container image:
  before_script: []
  image: '${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/crazymax/docker:20.10.9'
  script: |
    cd .devcontainer/
    awk 'BEGIN { print ENVIRON["CI_REGISTRY_PASSWORD"] }' | \
      docker login --username "${CI_REGISTRY_USER:?}" --password-stdin "${CI_REGISTRY:?}"
    if ! docker buildx imagetools inspect "${ID_IMAGE:?}"; then
      docker buildx create --platform linux/amd64 --use
      docker buildx build --build-arg IMAGE_PREFIX="${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX:?}/" --pull --push --tag "${ID_IMAGE:?}" --target development .
    fi
  services:
    - name: '${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:20.10.8-dind'
      alias: docker
  timeout: 5m

cache:
  key: '$CI_COMMIT_REF_SLUG'
  paths:
    - .pnpm-store/
    - node_modules/

security audit:on-schedule:
  needs: ['build container image']
  rules:
    - !reference [.rules_scheduled, rules]
  script:
    - pnpm audit
  timeout: 2m

lint:
  needs: ['build container image']
  rules:
    - !reference [.rules_unscheduled, rules]
  script:
    - pnpm lint
  timeout: 3m

pages:
  artifacts:
    paths:
      - public
  before_script: []
  cache: []
  needs:
    - job: build
      artifacts: true
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE != "schedule"
  script:
    - rm -fr public
    - mv build public
  timeout: 2m

variables:
  GIT_DEPTH: '1'
  ID_IMAGE: '$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG'

webhint:
  allow_failure: true
  artifacts:
    when: on_failure
    paths:
      - hint-report/
      - '$HOME/.npm/_logs/'
  needs: ['build container image']
  rules:
    - !reference [.rules_unscheduled, rules]
  script:
    - pnpm start
    - pnpm test:webhint
  timeout: 10m
